import { StatusOption } from '../API';
import { CRUDService, ICrudService } from '../core';
export declare class StatusOptionService extends CRUDService<StatusOption> {
    protected hasOneModels: ICrudService<StatusOption>['hasOneModels'];
    get create(): (input: Partial<Record<"externalStatuses", import("../../..").ModelWithId[]> & Record<import("../core").HasOneRelationsOf<StatusOption>, import("../../..").ModelWithId>> & Omit<import("../API").CreateStatusOption, "externalStatuses" | import("../core").HasOneRelationsOf<StatusOption>>, options?: import("../core").MutationOptionsWithoutMutation<import("@graphql-typed-document-node/core").TypedDocumentNode<import("../API").StatusOptionCreateOneMutation, import("../API").Exact<{
        input: import("../API").CreateStatusOption;
    }>>>) => Promise<{
        __typename?: "StatusOption";
        id: string;
        color?: string;
        value?: string;
        resolvesNeed?: boolean;
        sortIndex?: number;
        statusOptionMap?: {
            __typename?: "StatusOptionMap";
            id: string;
            color?: string;
            value: string;
        };
    }>;
    get update(): (input: Partial<Record<"externalStatuses", import("../../..").ModelWithId[]> & Record<import("../core").HasOneRelationsOf<StatusOption>, import("../../..").ModelWithId>> & Omit<import("../API").UpdateStatusOption, "externalStatuses" | import("../core").HasOneRelationsOf<StatusOption>> & {
        id: string;
    }, options?: import("../core").MutationOptionsWithoutMutation<import("@graphql-typed-document-node/core").TypedDocumentNode<import("../API").StatusOptionUpdateOneMutation, import("../API").Exact<{
        input: import("../API").UpdateOneStatusOptionInput;
    }>>>) => Promise<{
        __typename?: "StatusOption";
        id: string;
        color?: string;
        value?: string;
        resolvesNeed?: boolean;
        sortIndex?: number;
        inbox?: {
            __typename?: "Inbox";
            id: string;
        };
        statusOptionMap?: {
            __typename?: "StatusOptionMap";
            id: string;
            color?: string;
            value: string;
        };
    }>;
    get delete(): (id: string, options?: import("../core").MutationOptionsWithoutMutation<import("@graphql-typed-document-node/core").TypedDocumentNode<import("../API").StatusOptionDeleteOneMutation, import("../API").Exact<{
        input: import("../API").DeleteOneStatusOptionInput;
    }>>>) => Promise<{
        __typename?: "StatusOptionDeleteResponse";
        id?: string;
    }>;
    get get(): (id: string, options?: Omit<import("@apollo/client").QueryOptions<import("../API").Exact<{
        id: string;
    }>, import("../API").StatusOptionGetQuery>, "query">) => Promise<{
        __typename?: "StatusOption";
        id: string;
        color?: string;
        value?: string;
        statusOptionMap?: {
            __typename?: "StatusOptionMap";
            id: string;
            color?: string;
            value: string;
        };
    }>;
    get useGet(): (options: import("../core").ServiceQueryHookOptions<import("@graphql-typed-document-node/core").TypedDocumentNode<import("../API").StatusOptionGetQuery, import("../API").Exact<{
        id: string;
    }>>>) => {
        isLoading: boolean;
        isRefetching: boolean;
        hasMore: any;
        refetching: boolean;
        client: import("@apollo/client").ApolloClient<any>;
        observable: import("@apollo/client").ObservableQuery<import("../API").StatusOptionGetQuery, import("../API").Exact<{
            id: string;
        }>>;
        data: import("../API").StatusOptionGetQuery;
        previousData?: import("../API").StatusOptionGetQuery;
        error?: import("@apollo/client").ApolloError;
        loading: boolean;
        networkStatus: import("@apollo/client").NetworkStatus;
        called: boolean;
        variables: import("../API").Exact<{
            id: string;
        }>;
        startPolling: (pollInterval: number) => void;
        stopPolling: () => void;
        subscribeToMore: <TSubscriptionData = import("../API").StatusOptionGetQuery, TSubscriptionVariables = import("../API").Exact<{
            id: string;
        }>>(options: import("@apollo/client").SubscribeToMoreOptions<import("../API").StatusOptionGetQuery, TSubscriptionVariables, TSubscriptionData>) => () => void;
        updateQuery: <TVars = import("../API").Exact<{
            id: string;
        }>>(mapFn: (previousQueryResult: import("../API").StatusOptionGetQuery, options: Pick<import("@apollo/client").WatchQueryOptions<TVars, import("../API").StatusOptionGetQuery>, "variables">) => import("../API").StatusOptionGetQuery) => void;
        refetch: (variables?: Partial<import("../API").Exact<{
            id: string;
        }>>) => Promise<import("@apollo/client").ApolloQueryResult<import("../API").StatusOptionGetQuery>>;
        reobserve: (newOptions?: Partial<import("@apollo/client").WatchQueryOptions<import("../API").Exact<{
            id: string;
        }>, import("../API").StatusOptionGetQuery>>, newNetworkStatus?: import("@apollo/client").NetworkStatus) => Promise<import("@apollo/client").ApolloQueryResult<import("../API").StatusOptionGetQuery>>;
        fetchMore: <TFetchData = import("../API").StatusOptionGetQuery, TFetchVars = import("../API").Exact<{
            id: string;
        }>>(fetchMoreOptions: import("@apollo/client").FetchMoreQueryOptions<TFetchVars, TFetchData> & {
            updateQuery?: (previousQueryResult: import("../API").StatusOptionGetQuery, options: {
                fetchMoreResult: TFetchData;
                variables: TFetchVars;
            }) => import("../API").StatusOptionGetQuery;
        }) => Promise<import("@apollo/client").ApolloQueryResult<TFetchData>>;
    };
    get list(): (input: import("../API").Exact<{
        filter?: import("../API").StatusOptionFilter;
        sorting?: import("../API").StatusOptionSort | import("../API").StatusOptionSort[];
        paging?: import("../API").CursorPaging;
    }>, options?: import("../core").ServiceQueryOptions<import("@graphql-typed-document-node/core").TypedDocumentNode<import("../API").StatusOptionListQuery, import("../API").Exact<{
        filter?: import("../API").StatusOptionFilter;
        sorting?: import("../API").StatusOptionSort | import("../API").StatusOptionSort[];
        paging?: import("../API").CursorPaging;
    }>>>) => Promise<{
        __typename?: "StatusOptionConnection";
        totalCount: number;
        edges: {
            __typename?: "StatusOptionEdge";
            node: {
                __typename?: "StatusOption";
                id: string;
                color?: string;
                value?: string;
                resolvesNeed?: boolean;
                sortIndex?: number;
                statusOptionMap?: {
                    __typename?: "StatusOptionMap";
                    id: string;
                    color?: string;
                    value: string;
                };
            };
        }[];
        pageInfo: {
            __typename?: "PageInfo";
            endCursor?: any;
            hasNextPage?: boolean;
            hasPreviousPage?: boolean;
            startCursor?: any;
        };
    }>;
    get useList(): (options: import("../core").CacheUpdateOptions<import("../core").ServiceQueryHookOptions<import("@graphql-typed-document-node/core").TypedDocumentNode<import("../API").StatusOptionListQuery, import("../API").Exact<{
        filter?: import("../API").StatusOptionFilter;
        sorting?: import("../API").StatusOptionSort | import("../API").StatusOptionSort[];
        paging?: import("../API").CursorPaging;
    }>>>>) => {
        isLoading: boolean;
        isRefetching: boolean;
        hasMore: any;
        refetching: boolean;
        client: import("@apollo/client").ApolloClient<any>;
        observable: import("@apollo/client").ObservableQuery<import("../API").StatusOptionListQuery, import("../API").Exact<{
            filter?: import("../API").StatusOptionFilter;
            sorting?: import("../API").StatusOptionSort | import("../API").StatusOptionSort[];
            paging?: import("../API").CursorPaging;
        }>>;
        data: import("../API").StatusOptionListQuery;
        previousData?: import("../API").StatusOptionListQuery;
        error?: import("@apollo/client").ApolloError;
        loading: boolean;
        networkStatus: import("@apollo/client").NetworkStatus;
        called: boolean;
        variables: import("../API").Exact<{
            filter?: import("../API").StatusOptionFilter;
            sorting?: import("../API").StatusOptionSort | import("../API").StatusOptionSort[];
            paging?: import("../API").CursorPaging;
        }>;
        startPolling: (pollInterval: number) => void;
        stopPolling: () => void;
        subscribeToMore: <TSubscriptionData = import("../API").StatusOptionListQuery, TSubscriptionVariables = import("../API").Exact<{
            filter?: import("../API").StatusOptionFilter;
            sorting?: import("../API").StatusOptionSort | import("../API").StatusOptionSort[];
            paging?: import("../API").CursorPaging;
        }>>(options: import("@apollo/client").SubscribeToMoreOptions<import("../API").StatusOptionListQuery, TSubscriptionVariables, TSubscriptionData>) => () => void;
        updateQuery: <TVars = import("../API").Exact<{
            filter?: import("../API").StatusOptionFilter;
            sorting?: import("../API").StatusOptionSort | import("../API").StatusOptionSort[];
            paging?: import("../API").CursorPaging;
        }>>(mapFn: (previousQueryResult: import("../API").StatusOptionListQuery, options: Pick<import("@apollo/client").WatchQueryOptions<TVars, import("../API").StatusOptionListQuery>, "variables">) => import("../API").StatusOptionListQuery) => void;
        refetch: (variables?: Partial<import("../API").Exact<{
            filter?: import("../API").StatusOptionFilter;
            sorting?: import("../API").StatusOptionSort | import("../API").StatusOptionSort[];
            paging?: import("../API").CursorPaging;
        }>>) => Promise<import("@apollo/client").ApolloQueryResult<import("../API").StatusOptionListQuery>>;
        reobserve: (newOptions?: Partial<import("@apollo/client").WatchQueryOptions<import("../API").Exact<{
            filter?: import("../API").StatusOptionFilter;
            sorting?: import("../API").StatusOptionSort | import("../API").StatusOptionSort[];
            paging?: import("../API").CursorPaging;
        }>, import("../API").StatusOptionListQuery>>, newNetworkStatus?: import("@apollo/client").NetworkStatus) => Promise<import("@apollo/client").ApolloQueryResult<import("../API").StatusOptionListQuery>>;
        fetchMore: <TFetchData = import("../API").StatusOptionListQuery, TFetchVars = import("../API").Exact<{
            filter?: import("../API").StatusOptionFilter;
            sorting?: import("../API").StatusOptionSort | import("../API").StatusOptionSort[];
            paging?: import("../API").CursorPaging;
        }>>(fetchMoreOptions: import("@apollo/client").FetchMoreQueryOptions<TFetchVars, TFetchData> & {
            updateQuery?: (previousQueryResult: import("../API").StatusOptionListQuery, options: {
                fetchMoreResult: TFetchData;
                variables: TFetchVars;
            }) => import("../API").StatusOptionListQuery;
        }) => Promise<import("@apollo/client").ApolloQueryResult<TFetchData>>;
    };
    updateStatusOptionMap(id: string, relationId?: string): Promise<import("@apollo/client").FetchResult<import("../API").SetStatusOptionMapOnStatusOptionMutation>> | Promise<import("@apollo/client").FetchResult<import("../API").RemoveStatusOptionMapFromStatusOptionMutation>>;
    getStatusOptionMapIdFromCache(id: string): string;
    setStatusOptionMapOnStatusOption(id: string, relationId?: string): Promise<import("@apollo/client").FetchResult<import("../API").SetStatusOptionMapOnStatusOptionMutation>>;
    removeStatusOptionMapFromStatusOption(id: string, relationId?: string): Promise<import("@apollo/client").FetchResult<import("../API").RemoveStatusOptionMapFromStatusOptionMutation>>;
}
